//
// Created by bkg2k on 01/01/2020.
//

#include <map>
#include "SystemIcons.h"

static const std::map<std::string, const char*>& FavoritesIconsMap()
{
  static const std::map<std::string, const char*> _FavoritesIconsMap =
    {
      {"2048",               "\uF28c "},
      {"3do",                "\uF28d "},
      {"3ds",                "\uF28e "},
      {"64dd",               "\uF28f "},
      {"adam",               "\uF290 "},
      {"adventurevision",    "\uF291 "},
      {"amiga1200",          "\uF245 "},
      {"amiga500",           "\uF292 "},
      {"amiga600",           "\uF244 "},
      {"amigacd32",          "\uF293 "},
      {"amigacdtv",          "\uF294 "},
      {"amstradcpc",         "\uF295 "},
      {"apple2",             "\uF247 "},
      {"apple2gs",           "\uF296 "},
      {"arcadia",            "\uF297 "},
      {"astrocade",          "\uF298 "},
      {"atari2600",          "\uF23c "},
      {"atari5200",          "\uF23d "},
      {"atari7800",          "\uF23e "},
      {"atari800",           "\uF299 "},
      {"atarist",            "\uF29a "},
      {"atomiswave",         "\uF29b "},
      {"c64",                "\uF29c "},
      {"cannonball",         "\uF29d "},
      {"cavestory",          "\uF276 "},
      {"cdi",                "\uF29e "},
      {"channelf",           "\uF2a0 "},
      {"colecovision",       "\uF23f "},
      {"creativison",        "\uF29f "},
      {"daphne",             "\uF2a1 "},
      {"dinothawr",          "\uF2a2 "},
      {"doom",               "\uF277 "},
      {"doom3",              "\uF2a3 "},
      {"dos",                "\uF24a "},
      {"dragon",             "\uF2a4 "},
      {"dreamcast",          "\uF26e "},
      {"dungeoncrawlstonesoup",    "\uF2a5 "},
      {"easyrpg",            "\uF2a6 "},
      {"fba",                "\uF252 "},
      {"fbneo",              "\uF253 "},
      {"fds",                "\uF2a7 "},
      {"flashback",          "\uF2a8 "},
      {"gamecom",            "\uF2a9 "},
      {"gamecube",           "\uF262 "},
      {"gamegear",           "\uF26f "},
      {"gamemaster",         "\uF2aa "},
      {"gb",                 "\uF264 "},
      {"gba",                "\uF266 "},
      {"gbc",                "\uF265 "},
      {"gp32",               "\uF2ab "},
      {"gw",                 "\uF278 "},
      {"gx4000",             "\uF2ac "},
      {"imageviewer",        "\uF27b "},
      {"intellivision",      "\uF2ad "},
      {"ique",               "\uF2ae "},
      {"jaguar",             "\uF2af "},
      {"jaguarcd",           "\uF2b0 "},
      {"leapster",           "\uF2b1 "},
      {"loopy",              "\uF2b2 "},
      {"lutro",              "\uF27d "},
      {"lynx",               "\uF270 "},
      {"macintosh",          "\uF2b3 "},
      {"mame",               "\uF255 "},
      {"mastersystem",       "\uF26a "},
      {"megadrive",          "\uF26b "},
      {"minecraft",          "\uF2b4 "},
      {"model3",             "\uF2b5 "},
      {"moonlight",          "\uF27e "},
      {"mrboom",             "\uF2b6 "},
      {"msx1",               "\uF24e "},
      {"msx2",               "\uF24f "},
      {"msxturbor",          "\uF2b7 "},
      {"multivision",        "\uF2b8 "},
      {"n64",                "\uF260 "},
      {"naomi",              "\uF2b9 "},
      {"naomigd",            "\uF2ba "},
      {"nds",                "\uF267 "},
      {"neogeo",             "\uF257 "},
      {"neogeocd",           "\uF2bb "},
      {"nes",                "\uF25c "},
      {"ngp",                "\uF258 "},
      {"ngpc",               "\uF259 "},
      {"odyssey",            "\uF2bc "},
      {"odyssey2",           "\uF241 "},
      {"openbor",            "\uF2bd "},
      {"oricatmos",          "\uF2be "},
      {"palm",               "\uF2bf "},
      {"pc88",               "\uF2c0 "},
      {"pc98",               "\uF2c1 "},
      {"pcengine",           "\uF271 "},
      {"pcenginecd",         "\uF273 "},
      {"pcfx",               "\uF2c2 "},
      {"pcv2",               "\uF2c3 "},
      {"pico",               "\uF2c4 "},
      {"pippin",             "\uF2c5 "},
      {"plus4",              "\uF2c6 "},
      {"pokemini",           "\uF268 "},
      {"ports",              "\uF2c7 "},
      {"ps2",                "\uF2c8 "},
      {"ps3",                "\uF2c9 "},
      {"ps4",                "\uF2ca "},
      {"psp",                "\uF274 "},
      {"psvita",             "\uF2cb "},
      {"psx",                "\uF275 "},
      {"pv1000",             "\uF2cc "},
      {"quake",              "\uF2cd "},
      {"quake2",             "\uF2ce "},
      {"quake3",             "\uF2cf "},
      {"residualvm",         "\uF2d0 "},
      {"rickdangerous",      "\uF2d1 "},
      {"rpgmaker",           "\uF2d2 "},
      {"samcoupe",           "\uF2d3 "},
      {"satellaview",        "\uF2d4 "},
      {"saturn",             "\uF2d5 "},
      {"scummvm",            "\uF27a "},
      {"scv",                "\uF2d6 "},
      {"sega32x",            "\uF26c "},
      {"segacd",             "\uF26d "},
      {"sg1000",             "\uF269 "},
      {"snes",               "\uF25e "},
      {"solarus",            "\uF2d7 "},
      {"spectravideo",       "\uF2d8 "},
      {"startrekvoyager",    "\uF2d9 "},
      {"steam",              "\uF2da "},
      {"studio2",            "\uF2db "},
      {"stv",                "\uF2dc "},
      {"sufami",             "\uF2dd "},
      {"superacan",          "\uF2de "},
      {"supergrafx",         "\uF272 "},
      {"supermariowar",      "\uF2df "},
      {"supervision",        "\uF2e0 "},
      {"supervision8000",    "\uF2e1 "},
      {"switch",             "\uF2e2 "},
      {"thomson",            "\uF2e3 "},
      {"tic80",              "\uF2e4 "},
      {"tombraider",         "\uF2e5 "},
      {"uzebox",             "\uF2e6 "},
      {"vectrex",            "\uF240 "},
      {"vic20",              "\uF2e7 "},
      {"videopacplus",       "\uF2e8 "},
      {"virtualboy",         "\uF25f "},
      {"vsmile",             "\uF2e9 "},
      {"wii",                "\uF263 "},
      {"wiiu",               "\uF2ea "},
      {"wolfenstein3d",      "\uF2eb "},
      {"wswan",              "\uF25a "},
      {"wswanc",             "\uF25b "},
      {"x1",                 "\uF2ec "},
      {"x68000",             "\uF2ed "},
      {"xbox",               "\uF2ee "},
      {"xbox360",            "\uF2ef "},
      {"xboxone",            "\uF2f0 "},
      {"zx81",               "\uF250 "},
      {"zxspectrum",         "\uF251 "},
      {"zxspectrum3",        "\uF2f1 "},
    };
  return _FavoritesIconsMap;
}

const char* SystemIcons::GetIcon(const std::string& systemShortName)
{
  const std::map<std::string, const char*>& map = FavoritesIconsMap();
  auto it = map.find(systemShortName);
  if (it != map.end())
    return it->second;
  return nullptr;
}

